//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function SetConvars()
{
    Convars.SetValue("tf_weapon_criticals", 1);
    Convars.SetValue("mp_teams_unbalance_limit", 0);
    Convars.SetValue("mp_respawnwavetime", 999999);
    Convars.SetValue("tf_classlimit", 0);
    Convars.SetValue("mp_forcecamera", 0);
    Convars.SetValue("sv_alltalk", 1);
    Convars.SetValue("tf_dropped_weapon_lifetime", 0);
    Convars.SetValue("mp_idledealmethod", 0);
    Convars.SetValue("mp_idlemaxtime", 9999);
    Convars.SetValue("mp_scrambleteams_auto", 0);
    Convars.SetValue("mp_stalemate_timelimit", 9999999);
    Convars.SetValue("mp_scrambleteams_auto_windifference", 0);
    Convars.SetValue("mp_winlimit", 0);
    Convars.SetValue("mp_maxrounds", 0);
    Convars.SetValue("mp_humans_must_join_team", "red");
    if (GetPersistentVar("mp_bonusroundtime") == null)
        SetPersistentVar("mp_bonusroundtime", Convars.GetInt("mp_bonusroundtime"));
}
SetConvars();

function SpawnHelperEntities()
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    SetPropString(gamerules, "SetBlueTeamGoalString", "Kill all Mercenaries");
    SetPropString(gamerules, "SetRedTeamGoalString", "Kill Saxton Hale");

    local teamFilterHale = SpawnEntityFromTable("filter_activator_tfteam", {
        Negated = 0,
        TeamNum = 3,
        targetname = "filter_team_hale",
    })

    local teamFilterMercs = SpawnEntityFromTable("filter_activator_tfteam", {
        Negated = 0,
        TeamNum = 2,
        targetname = "filter_team_mercs",
    })

    local trigger = SpawnEntityFromTable("trigger_multiple", {
        origin = "0 0 0",
        spawnflags = 1,
        IsEnabled = false,
        StartDisabled = 1,
        filtername = "filter_team_mercs",
        targetname = "hale_charge_zone",
    });

    trigger.KeyValueFromInt("solid", 2)
    trigger.KeyValueFromString("mins", "-55 -55 -20")
    trigger.KeyValueFromString("maxs", "55 55 120")
    EntityOutputs.AddOutput(trigger, "OnStartTouch", vsh_vscript_name, "RunScriptCode","haleChargeAbility.BashTarget(activator)", 0, -1)

    trigger = SpawnEntityFromTable("trigger_catapult", {
        origin = "0 0 0",
        spawnflags = 1,
        StartDisabled = 1,
        IsEnabled = false,
        physicsSpeed = 300,
        playerSpeed = 300,
        launchDirection = "-90 270 0",
        filtername = "filter_team_hale",
        targetname = "hale_charge_catapult"
    })

    trigger.KeyValueFromInt("solid", 2)
    trigger.KeyValueFromString("mins", "-64 -64 -96")
    trigger.KeyValueFromString("maxs", "64 64 96")

    if (!injectRoundLogic)
        return;

    local forceRespawn = Entities.FindByClassname(null, "game_forcerespawn");
    if (forceRespawn == null)
        SpawnEntityFromTable("game_forcerespawn", {});

    local controlPoint = Entities.FindByClassname(null, "team_control_point");
    controlPoint.KeyValueFromInt("point_index", 0);
    controlPoint.KeyValueFromInt("point_start_locked", 1);
    EntFireByHandle(controlPoint, "SetLocked", "1", 0, null, null);
    EntityOutputs.AddOutput(controlPoint,
        "OnUnlocked",
        "!self",
        "ShowModel",
        "",
        0, -1);
    EntityOutputs.AddOutput(controlPoint,
        "OnCapReset",
        "!self",
        "HideModel",
        "",
        0, -1);
    EntityOutputs.AddOutput(controlPoint,
        "OnCapTeam"+(TF_TEAM.MERCS-1),
        vsh_vscript_name,
        "RunScriptCode",
        "EndRound("+TF_TEAM.MERCS+")",
        0, -1);
    EntityOutputs.AddOutput(controlPoint,
        "OnCapTeam"+(TF_TEAM.HALE-1),
        vsh_vscript_name,
        "RunScriptCode",
        "EndRound("+TF_TEAM.HALE+")",
        0, -1);

    local pointMaster = Entities.FindByClassname(null, "team_control_point_master");
    if (pointMaster == null)
        SpawnEntityFromTable("team_control_point_master", {
            caplayout = 0,
            cpm_restrict_team_cap_win = 1,
            custom_position_x = -1,
            custom_position_x = -1,
            partial_cap_points_rate = 0
        });

    local pdLogic = Entities.FindByClassname(null, "tf_logic_player_destruction");
    if (pdLogic == null)
    {
        SpawnEntityFromTable("tf_logic_player_destruction", {
            blue_respawn_time = 9999,
            finale_length = 999999,
            flag_reset_delay = 60,
            heal_distance = 0,
            min_points = 1,
            points_per_player = 0,
            red_respawn_time = 0,
            targetname = "pd_logic",
            res_file = "Resource/UI/HudObjectivePDVSH.res"
        });

        local auto = SpawnEntityFromTable("logic_auto", {
            spawnflags = 1,
            "OnMultiNewRound#1": "pd_logic,SetPointsOnPlayerDeath,0,0,-1",
            "OnMultiNewRound#2": "pd_logic,EnableMaxScoreUpdating,,0,-1",
            "OnMultiNewRound#3": "pd_logic,DisableMaxScoreUpdating,,5,-1",
        });
    }

    local roundTimer = Entities.FindByClassname(null, "team_round_timer");
    if (roundTimer != null)
        roundTimer.Kill();
    SpawnEntityFromTable("team_round_timer", {
        targetname = "team_round_timer",
        auto_countdown = 1,
        max_length = 0,
        reset_time = 1,
        setup_length = setupLength,
        show_in_hud = 1,
        show_time_remaining = 1,
        start_paused = 0,
        timer_length = 240,
        StartDisabled = 0,
        "OnSetupFinished#1": "!self,RunScriptFile,vssaxtonhale/external_calls/finish_round_setup.nut,0,-1",
        "OnSetupFinished#2": "vsh_setup*,Trigger,,0,-1",
        "OnSetupFinished#3": "vsh_setup*,Open,,0,-1",
        "OnFinished": "!self,RunScriptFile,vssaxtonhale/external_calls/unlock_control_point.nut,0,-1"
    });

    local feedbackRelay = SpawnEntityFromTable("logic_relay", {
        targetname = "TF2M_FeedbackRoundRelay",
        spawnflags = 0,
        "OnTrigger": "!self,RunScriptFile,vssaxtonhale/external_calls/set_feedback_round.nut,0,-1",
    });

    feedbackRelay.ValidateScriptScope();
    feedbackRelay.GetScriptScope().Tick <- function()
    {
        if (vsh_vscript.IsValidRound())
            vsh_vscript.FireListeners("tick_frame", null);
        return 0;
    }
    AddThinkToEnt(feedbackRelay, "Tick")
}
SpawnHelperEntities();

function UnlockControlPoint()
{
    local controlPoint = Entities.FindByClassname(null, "team_control_point");
    if (controlPoint != null)
        EntFireByHandle(controlPoint, "SetUnlockTime", "0", 0, null, null);
}