//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function SpawnTextEntities(void)
{
    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 0,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0asd",
        spawnflags = 1,
        x = -1,
        y = 0.1225,
        targetname = "game_text_hale_hp"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.481,
        y = 0.788,
        targetname = "game_text_damage"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.27,
        y = 0.6725,
        targetname = "game_text_hale_charge"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 2,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.53,
        y = 0.6725,
        targetname = "game_text_hale_slam"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 4,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.58,
        targetname = "game_text_hale_punch"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 5,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 1,
        x = 0.493,
        y = 0.854,
        targetname = "game_text_players_alive"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 3,
        effect = 0,
        fadein = 0.5,
        fadeout = 0.5,
        fxtime = 0.25,
        holdtime = 500,
        message = "",
        spawnflags = 1,
        x = -1,
        y = 0.35,
        targetname = "game_text_victory_screen"
    });
}
SpawnTextEntities(null);

function TickHUD(interval)
{
    local hale = GetHale();
    local aliveMercs = GetAliveMercCount();

    //0.493
    local offset = aliveMercs < 10 ? 0.498 : 0.495;
    DoEntFire("game_text_hale_hp", "AddOutput", "message " + (IsValidPlayer(hale) ? hale.GetHealth() : " "), 0, null, null);
    DoEntFire("game_text_hale_hp", "Display", "", 0, null, null);
    DoEntFire("game_text_players_alive", "AddOutput", "message "+aliveMercs, 0, null, null);
    DoEntFire("game_text_players_alive", "AddOutput", "x "+offset, 0, null, null);
    DoEntFire("game_text_players_alive", "Display", "", 0, null, null);
    DoEntFire("game_text_victory_screen", "Display", "", 0, null, null);

    local haleMaxHP = hale.GetMaxHealth();
    local tf_player_manager = Entities.FindByClassname(null, "tf_player_manager");
    foreach (player in GetAllValidMercs())
    {
        //Your Damage∶
        local number = 0;
        if (player.GetPlayerClass() != TF_CLASS.MEDIC)
            number = floor(player in damage ? damage[player] : 0);
        else
            number = GetPropIntArray(tf_player_manager, "m_iHealing", player.entindex());
        local offset = number < 10 ? 0.498 : number < 100 ? 0.493 : number < 1000 ? 0.491 : 0.487;

        DoEntFire("game_text_damage", "AddOutput", "message " + number, 0, player, player);
        DoEntFire("game_text_damage", "AddOutput", "x "+offset, 0, player, player);
        DoEntFire("game_text_damage", "Display", "", 0, player, player);
    }

    if (IsValidPlayer(hale) && GetPropString(hale, "m_szNetworkIDString") != "[U:1:61845546]")
    {
        local msg = haleChargeAbility.MeterValueAsString();
        DoEntFire("game_text_hale_charge", "AddOutput", "message             Charge∶ "+msg+"\n(Hold Action Slot or Reload)", 0, hale, hale);
        DoEntFire("game_text_hale_charge", "Display", "", 0, hale, hale);

        msg = haleSlamAbility.MeterValueAsString();
        DoEntFire("game_text_hale_slam", "AddOutput", "message        Slam∶ "+msg+"\n(Hold Crouch mid-air)", 0, hale, hale);
        DoEntFire("game_text_hale_slam", "Display", "", 0, hale, hale);

        msg = haleSaxtonPunchAbility.MeterValueAsString();
        DoEntFire("game_text_hale_punch", "AddOutput", "message Saxton PUNCH!∶ "+msg+"\nBrave Jump∶ Double Jump", 0, hale, hale);
        DoEntFire("game_text_hale_punch", "Display", "", 0, hale, hale);
    }
}
AddListener("tick_only_valid", TickHUD, 2);