//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class ReceivedDamageScalingChange extends HaleChange
{
    accumulatorHP = 0;

    function OnTick(interval)
    {
        local accDelta = accumulatorHP - player.GetHealth();
        //printl("accDelta="+accDelta);
        accumulatorHP -= accDelta * interval / 2;
        if (accumulatorHP < player.GetHealth())
            accumulatorHP = player.GetHealth();
    }

    function OnDamageTaken(params)
    {
        local mercMultiplier = clampFloor(1, 1.85 - (vsh_vscript.GetAliveMercCount() * 1.0) / vsh_vscript.startMercCount);
        //printl("mercMultiplier="+mercMultiplier);

        local accDelta = accumulatorHP - player.GetHealth();
        //printl("accDelta="+accDelta);
        local resistance = 0.5 + clampFloor(0, 0.5 - (accDelta / 4000.0));
        //printl("clampFloor="+clampFloor(0, 0.5 - (accDelta / 4000.0)));
        //printl("resistance="+resistance);
        //printl("total="+mercMultiplier * resistance);

        local totalMultiplier = mercMultiplier * resistance;
        printl("accDelta="+totalMultiplier);
        if (totalMultiplier <= 0.9 || totalMultiplier >= 1.1)
            params.damage *= totalMultiplier;
    }
}
characterChangesClasses.push(ReceivedDamageScalingChange);