//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class StunBreakOutHaleAbility extends HaleChange
{
    stunTimer = 0;
    stunInitHealth = 0;
    holidayPunchTimeStamp = 0;

    function OnTick(interval)
    {
        if (player.IsControlStunned() || (Time() - holidayPunchTimeStamp <= 4 && player.InCond(Constants.ETFCond.TF_COND_TAUNTING)))
        {
            stunTimer += interval;

            if (stunInitHealth == 0)
                stunInitHealth = player.GetHealth();
            else if (player.GetHealth() < stunInitHealth - 2000)
            {
                DoBreakOut();
                return;
            }
        }
        else if (stunTimer > 0)
            stunTimer -= interval;
        if (stunTimer < 0)
        {
            stunTimer = 0;
            stunInitHealth = 0;
        }

        if (stunTimer >= 4)
            DoBreakOut();
    }

    function OnDamageTaken(params)
    {
        if (WeaponIs(params.weapon, "holiday_punch"))
            holidayPunchTimeStamp = Time();
    }

    function DoBreakOut()
    {
        stunTimer = 0;
        stunInitHealth = 0;

        local hale = player;
        EmitSoundOn("VSH.Rage", player);
        player.RemoveCond(Constants.ETFCond.TF_COND_STUNNED);
        player.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
        player.Yeet(Vector(0,0,800));

        DispatchParticleEffect("hammer_impact_button", player.GetOrigin() + Vector(0,0,20), Vector(0,0,0));
        EmitSoundOn("VSH.Slam.Impact", player);

        vsh_vscript.CreateAoE(hale.GetCenter(), 400,
            function (target, deltaVector, distance) {
                target.TakeDamageEx(
                    hale,
                    hale,
                    hale.GetActiveWeapon(),
                    deltaVector,
                    hale.GetOrigin(),
                    1,
                    1);
            }
            function (target, deltaVector, distance) {
                local pushForce = distance < 100 ? 10 : 10 / sqrt(distance);
                deltaVector.x = deltaVector.x * 1450 * pushForce;
                deltaVector.y = deltaVector.y * 1450 * pushForce;
                deltaVector.z = 450 * pushForce;
                target.Yeet(deltaVector);
            });
    }
}
characterChangesClasses.push(StunBreakOutHaleAbility);