//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

hitStreak <- {};
ignoreWallClimb <- [
    "player",
    "tf_bot",
    "obj_sentrygun",
    "obj_dispenser",
    "obj_teleporter"
]

function MeleeWallClimb_Hit(params)
{
    local player = params.attacker;
    if (!IsValidPlayer(player) || IsHale(player))
        return;
    MeleeClimb_Perform(player);
}

function MeleeWallClimb_Check(params)
{
    return ignoreWallClimb.find(params.const_entity.GetClassname()) == null;
}

function MeleeWallClimb_Tick(void)
{
    foreach (player in GetAliveMercs())
        if ((player.GetFlags() & Constants.FPlayer.FL_ONGROUND))
            vsh_vscript.hitStreak[player] <- 0;
}
AddListener("tick_always", MeleeWallClimb_Tick, 0);

function MeleeClimb_Perform(player)
{
    local hits = tablevalue(hitStreak, player, 0) + 1;
    local launchVelocity = hits == 1 ? 600 : hits == 2 ? 450 : 400;
    hitStreak[player] <- hits;

    //RunWithDelay("activator.Yeet(activator.EyeAngles().Forward() * 200)", player, 0.15);

    SetPropEntity(player, "m_hGroundEntity", null);
    player.RemoveFlag(Constants.FPlayer.FL_ONGROUND);

    local newVelocity = player.GetAbsVelocity();
    if (hits == 2)
    {
        newVelocity.x /= 2;
        newVelocity.y /= 2;
    }
    newVelocity.z = launchVelocity > 430 ? launchVelocity : launchVelocity + newVelocity.z;
    player.SetAbsVelocity(newVelocity);
}