//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

class EngineerSentryChange extends CharacterChange
{
    sentryDamageAccumulated = 0;
    lastHitWasSentry = false;

    function CanApply()
    {
        return player.GetPlayerClass() == TF_CLASS.ENGINEER;
    }

    function OnDamageDealt(params)
    {
        if (params.inflictor != null && params.inflictor.GetClassname() == "obj_sentrygun")
        {
            //Nerfing damage and knockback by 50%.
            //There's an attribute that gives sentry resistance, but it doesn't give knockback res
            params.damage *= 0.5;
            lastHitWasSentry = true;
        }
        else
            lastHitWasSentry = false;
    }

    function OnHurtDealtEvent(victim, params)
    {
        if (lastHitWasSentry)
        {
            //Frontier Justice crits.
            sentryDamageAccumulated += params.damage;
            while (sentryDamageAccumulated >= 500)
            {
                AddPropInt(params.inflictor, "SentrygunLocalData.m_iAssists", 1);
                sentryDamageAccumulated -= 500;
            }
        }
    }

    //This is how we keep Engineer [s]Gaming[/s] Buildings during Sudden Death - we turn it off for 1 frame.
    function OnDeath(params)
    {
        SetPropInt(Entities.FindByClassname(null, "tf_gamerules"), "m_iRoundState", 0);
        RunWithDelay("SetPropInt(Entities.FindByClassname(null, \"tf_gamerules\"), \"m_iRoundState\", 7)", null, 0);
    }
}
characterChangesClasses.push(EngineerSentryChange);