//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function TrySpawnAsMerc(player)
{
    if (!IsMercAlive(player))
        return;

    if (!IsRoundSetup())
    {
        player.TakeDamage(9999, 0, null);
        SetPropInt(player, "m_lifeState", LIFE_STATE.DEAD);
        if (player.GetTeam() != TF_TEAM.MERCS)
            player.ForceChangeTeam(TF_TEAM.MERCS, true);

        local ammoPack = null;
        while (ammoPack = Entities.FindByClassname(ammoPack, "tf_ammo_pack"))
            if (ammoPack.GetOwner() == player)
                ammoPack.Destroy();
    }

    printl("TrySpawnAsMerc for "+player);

    player.SetCustomModelWithClassAnimations("")
    player.SetGravity(1);
    SetPropInt(player, "m_bForcedSkin", 0);

    if (player.GetTeam() != TF_TEAM.MERCS)
    {
        player.SwitchTeam(TF_TEAM.MERCS);
        player.ForceRegenerateAndRespawn();
    }

    if (player.GetPlayerClass() == TF_CLASS.HEAVY && GetItemID(player.ReturnWeaponBySlot(0)) == 41)
    {
        player.GiveWeapon("Minigun");
        ClientPrint(player, 3, "Natasha is TEMPORARILY disabled.");
    }
}
AddListener("spawn", TrySpawnAsMerc, 0);

function MercClassChange(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;
    local currentClass = GetPropInt(player, "m_PlayerClass.m_iClass");
    local desiredClass = params["class"];

    if (IsRoundSetup() && IsNotHale(player))
    {
        player.SetPlayerClass(desiredClass);
        player.ForceRegenerateAndRespawn();

        local building = null;
        while (building = Entities.FindByClassname(building, "obj_*"))
            if (GetPropEntity(building, "m_hBuilder") == player)
                building.Kill();
    }
    else
    {
        SetPropInt(player, "m_PlayerClass.m_iClass", desiredClass);
        RunWithDelay("SetPropInt(activator, \"m_PlayerClass.m_iClass\", "+currentClass+")", player, 0);
    }
}
AddListener("class_change", MercClassChange, 0);

function MercTeamChange(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    local hale = GetHale();
    if (player == hale && params.team != TF_TEAM.HALE)
        RunWithDelay("SwitchPlayerTeam(activator, TF_TEAM.HALE)", player, 0);
    if (player != hale && params.team == TF_TEAM.HALE)
        RunWithDelay("SwitchPlayerTeam(activator, TF_TEAM.MERCS)", player, 0);
    if (player != hale && params.team == TF_TEAM.SPECTATORS && params.silent)
    {
        local name = GetPropString(player, "m_szNetname");
        Say(null, "Player '"+name+"' was moved to spectators for some reason. Moving them back.", false);
        RunWithDelay("SwitchPlayerTeam(activator, TF_TEAM.MERCS)", player, 0);
    }
}
AddListener("team_change", MercTeamChange, 0);