//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

listeners <- {}

//The higher the value the LATER it will execute
function AddListener(event, listener, order)
{
    local listenerPair = [order, listener];
    if (event in listeners)
    {
        local queue = listeners[event]
        local size = queue.len()
        local i = 0
        for (; i < size; i++)
            if (queue[i][0] > order)
                break
        queue.insert(i, listenerPair)
    }
    else
        listeners[event] <- [listenerPair]
    return listenerPair;
}

//Removing listeners is not really intended,
//  but in case you need it, you can store the return of `AddListener` in a variable,
//  and then pass that variable to `RemoveListener`.
function RemoveListener(listenerPair)
{
    if (event in listeners)
        listeners.remove(listenerPair);
}

function FireListeners(event, params)
{
    if (!(event in listeners))
        return;

    foreach (entry in listeners[event])
    {
        try { entry[1].call(this, params) }
        catch(e) {}
    }
}