//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function PlaySoundForAll(soundScript)
{
    foreach (player in GetAllValidPlayers())
        EmitSoundOnClient(soundScript, player);
}

::clampCeiling <- function(valueA, valueB)
{
    if (valueA < valueB)
        return valueA;
    return valueB;
}

::clampFloor <- function(valueA, valueB)
{
    if (valueA > valueB)
        return valueA;
    return valueB;
}

::clamp <- function(value, min, max)
{
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}

function IsNotValidRound()
{
    return isFeedbackRound || IsInWaitingForPlayers() || IsNotHale(GetHale());
}

function IsValidRound()
{
    return !isFeedbackRound && !IsInWaitingForPlayers() && IsHale(GetHale());
}

function IsRoundSetup()
{
    return isRoundSetup;
}

function IsRoundOver()
{
    return isRoundOver;
}

::SetPersistentVar <- function(name, value)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    persistentVars[name] <- value;
}

::GetPersistentVar <- function(name, defValue = null)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local persistentVars = gamerules.GetScriptScope();
    return name in persistentVars ? persistentVars[name] : defValue;
}

::RunWithDelay <- function(func, activator, delay)
{
    EntFireByHandle(vsh_vscript_entity, "RunScriptCode", func, delay, activator, activator);
}

::tablevalue <- function(table, key, defValue = null)
{
    return key in table ? table[key] : defValue
}


::RealTimeProxy <- function()
{
    return RealTime();
}